Summary: The zlib compression and decompression library.
Name: zlib
Version: 1.2.11
Release: 1
Group: System Environment/Libraries
Source0: http://sourceforge.net/projects/libpng/files/zlib/1.2.8/zlib-%{version}.tar.gz
#Source1: IBM_ILA
#Source2: zlib.txt
Patch0: zlib-1.2.11-aix.patch
URL: http://www.zlib.net/
License: zlib
Prefix: %{_prefix}
Buildroot:%{_tmppath}/%{name}-root
 

%define prefix64 %{prefix}/64

%description
The zlib compression library provides in-memory compression and decompression
functions, including integrity checks of the uncompressed data.  This version
of the library supports only one compression method (deflation), but other
algorithms may be added later, which will have the same stream interface.  The
zlib library is used by many different system programs.

%package devel
Summary: Header files and libraries for developing apps which will use zlib.
Group: Development/Libraries
Requires: zlib

%description devel
The zlib-devel package contains the header files and libraries needed to
develop programs that use the zlib compression and decompression library.

Install the zlib-devel package if you want to develop applications that will
use the zlib library.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p0 

# Put License into place
#cat $RPM_SOURCE_DIR/IBM_ILA > LICENSE
#cat $RPM_SOURCE_DIR/zlib.txt >> LICENSE

export AR="/usr/bin/ar -X32_64"
export NM="/usr/bin/nm -X32_64"
export CFLAGS="-qmaxmem=-1 -O3"

#64 bit
mkdir 64bit
cd 64bit
gunzip -dc %{SOURCE0} |tar -xf -
cd %{name}-%{version}
%patch0 -p0 

export CC="xlc -q64"
export OBJECT_MODE=64

./configure \
    --prefix=%{_prefix64} \
    --static
make %{?_smp_mflags}

CreateExportList -X64 %{name}.exp libz.a
${CC} -qmkshrobj libz.a -o libz.so.1 -bE:%{name}.exp
rm -f %{name}.exp libz.a

#32 bit
cd ../../
export CC="xlc"
export OBJECT_MODE=32
./configure \
    --prefix=%{_prefix} \
    --static
make %{?_smp_mflags}

CreateExportList -X32 %{name}.exp libz.a
${CC} -qmkshrobj libz.a -o libz.so.1 -bE:%{name}.exp
rm -f %{name}.exp libz.a

${AR} -rv libz.a libz.so.1
${AR} -q libz.a 64bit/%{name}-%{version}/libz.so.1

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}

make install prefix=${RPM_BUILD_ROOT}%{_prefix}


( cd $RPM_BUILD_ROOT/%{prefix}/lib
  #rm libz.so*

  # Create a compatibility member to mitigate differences with Bull Freeware
  # offering
  COMPATMEMBER=shr.o
  for lib in *.a
  do
    /usr/bin/dump -X32 -Tv $lib |/usr/bin/awk 'match($4,"EXP|Exp") { print $NF }' > tmp.exp
    libbase=`echo $lib | sed  -e 's/.a$//' -e 's/^lib//'`
    ld -L. -bI:tmp.exp -bE:tmp.exp -l$libbase -bM:SRE -bnoentry -bnolibpath -o $COMPATMEMBER
    /usr/bin/strip -e $COMPATMEMBER   # Make shr.o a load-only module
    /usr/bin/ar -q $lib $COMPATMEMBER
    rm -f $COMPATMEMBER tmp.exp
  done
)

(
  cd ${RPM_BUILD_ROOT}
  for dir in include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)

#Add links for 64-bit library members
(
 mkdir -p $RPM_BUILD_ROOT/%{prefix64}/lib
 cd $RPM_BUILD_ROOT/%{prefix64}/lib
 ln -s ../../lib/*.a .
)

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,system)
%doc README ChangeLog FAQ
%{_prefix}/lib/libz*
/usr/lib/libz*
%{prefix64}/lib/lib*.a


%files devel
%defattr(-,root,system)
%doc doc/algorithm.txt test/minigzip.c test/example.c
%{_prefix}/include/*
%{_libdir}/pkgconfig/zlib.pc
/usr/include/*
%{_prefix}/man/man3/zlib*

%changelog
* Tue Jul 30 2013 Sangamesh Mallayya <smallayy@in.ibm.com> 1.2.7-1
- Update to 1.2.7

* Thu Jan  3 2008 Reza Arbab <arbab@austin.ibm.com> 1.2.3-4
- Compile with -O3.

* Fri Jul 15 2005 Philip K. Warren <pkw@us.ibm.com> 1.2.2-4
- Fix libpath issue in shr.o compatability member.

* Tue Jul 12 2005 Reza Arbab <arbab@austin.ibm.com> 1.2.2-3
- Apply security fix for Mozilla bugzilla bug 300349.

* Thu Jul 07 2005 Philip K. Warren <pkw@us.ibm.com> 1.2.2-2
- Apply security fix for CAN-2005-2096.

* Thu Jun 09 2005 David Clissold <cliss@austin.ibm.com> 1.2.2-1
- Update to version 1.2.2.

* Tue Nov 30 2004 David Clissold <cliss@austin.ibm.com> 1.2.1-2
- Add small security patch, backported from 1.2.2.

* Tue Apr 20 2004 David Clissold <cliss@austin.ibm.com> 1.2.1-1
- Update to version 1.2.1.

* Fri Feb 13 2004 David Clissold <cliss@austin.ibm.com> 1.1.4-4
- Build 64-bit library version.

* Fri May 23 2003 David Clissold <cliss@austin.ibm.com>
- Add patch for potential buffer overflow.  See CERT VU#142121.

* Fri Nov 22 2002 David Clissold <cliss@austin.ibm.com>
- Add IBM ILA license.

* Mon Mar 11 2002 David Clissold <cliss@austin.ibm.com>
- Update to version 1.1.4

* Tue Mar 20 2001 Marc Stephenson <marc@austin.ibm.com>
- Build both 32- and 64-bit binaries

* Thu Mar 08 2001 Marc Stephenson <marc@austin.ibm.com>
- Handle non-gcc IA64 compilers

* Wed Mar 07 2001 Marc Stephenson <marc@austin.ibm.com>
- Add logic for default compiler
- Generate real archive on Power
- Add compatibility entry for Bull freeware

* Tue Feb 20 2001 aixtoolbox <aixtoollbox-l@austin.ibm.com>
- Account for different standard lib location in IA64 32-bit ABI

* Fri Oct 27 2000 pkgmgr <pkgmgr@austin.ibm.com>
- Modify for AIX Freeware distribution

* Mon Feb  7 2000 Jeff Johnson <jbj@redhat.com>
- compress man page.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 5)

* Wed Sep 09 1998 Cristian Gafton <gafton@redhat.com>
- link against glibc

* Mon Jul 27 1998 Jeff Johnson <jbj@redhat.com>
- upgrade to 1.1.3

* Fri May 08 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Apr 08 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 1.1.2
- buildroot

* Tue Oct 07 1997 Donnie Barnes <djb@redhat.com>
- added URL tag (down at the moment so it may not be correct)
- made zlib-devel require zlib

* Thu Jun 19 1997 Erik Troan <ewt@redhat.com>
- built against glibc
